## pentobi 8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)

# Use all lower-case for project name because it is used in
# CMAKE_INSTALL_DOCDIR of GNUInstallDirs
project(pentobi)
set(PENTOBI_VERSION 8.0)

if(POLICY CMP0020)
  # Remove once we require CMake 2.8.11
  cmake_policy(SET CMP0020 OLD)
endif()

include(CheckIncludeFiles)
include(GNUInstallDirs)

option(PENTOBI_BUILD_TESTS "Build unit tests" OFF)
option(PENTOBI_BUILD_GTP "Build GTP interface" OFF)
option(PENTOBI_BUILD_GUI "Build Qt-based GUI" ON)
option(PENTOBI_BUILD_KDE_THUMBNAILER
  "Build thumbnailer for KDE (also requires PENTOBI_BUILD_GUI)" OFF)
option(USE_QT5 "Use Qt 5 instead of Qt 4" OFF)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE "Release")
endif()
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DLIBBOARDGAME_DEBUG")

if(CMAKE_COMPILER_IS_GNUCXX OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    OR (CMAKE_CXX_COMPILER_ID MATCHES "Intel"))
  add_definitions(-std=c++11)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
  add_definitions(-ffast-math)
endif()
if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE
    -D_SCL_SECURE_NO_WARNINGS)
endif()

check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(sys/times.h HAVE_SYS_TIMES_H)
check_include_files(sys/sysctl.h HAVE_SYS_SYSCTL_H)

if(NOT DEFINED LIBPENTOBI_MCTS_FLOAT_TYPE)
  set(LIBPENTOBI_MCTS_FLOAT_TYPE float)
endif()

# Don't set the Pentobi data dirs on Windows. This is currently needed for
# building a version of Pentobi for the NSIS installer on Windows (see
# directory windows_installer) such that Pentobi will look for data dirs
# relative to the installation directory. (It breaks installing Pentobi on
# Windows with "make install" but we don't support that on Windows anyway.)
if(UNIX)
  if(NOT DEFINED PENTOBI_BOOKS_DIR)
    set(PENTOBI_BOOKS_DIR "${CMAKE_INSTALL_FULL_DATADIR}/pentobi/books")
  endif()
  if(NOT DEFINED PENTOBI_MANUAL_DIR)
    set(PENTOBI_MANUAL_DIR "${CMAKE_INSTALL_FULL_DOCDIR}/manual")
  endif()
  if(NOT DEFINED PENTOBI_TRANSLATIONS)
    set(PENTOBI_TRANSLATIONS
      "${CMAKE_INSTALL_FULL_DATADIR}/pentobi/translations")
  endif()
endif(UNIX)

configure_file(config.h.in config.h)
add_definitions(-DHAVE_CONFIG_H)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(PENTOBI_BUILD_TESTS)
  enable_testing()
endif()

find_package(Threads)

if(PENTOBI_BUILD_GUI)
  if (USE_QT5)
    find_package(Qt5Widgets REQUIRED)
    find_package(Qt5Concurrent REQUIRED)
    find_package(Qt5LinguistTools REQUIRED)
  else()
    find_package(Qt4 COMPONENTS QtCore QtGui QtSvg REQUIRED)
  endif()
endif()

if(UNIX)
  add_custom_target(dist
    COMMAND git archive --prefix=pentobi-${PENTOBI_VERSION}/ HEAD
    | xz > ${CMAKE_BINARY_DIR}/pentobi-${PENTOBI_VERSION}.tar.xz
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  add_custom_target(post-install
    COMMAND
    update-mime-database ${CMAKE_INSTALL_FULL_DATAROOTDIR}/mime\;
    update-desktop-database ${CMAKE_INSTALL_FULL_DATAROOTDIR}/applications\;
    )
endif()

install(FILES README NEWS COPYING doc/blksgf/Pentobi-SGF.html
  DESTINATION ${CMAKE_INSTALL_DOCDIR})

add_subdirectory(doc)
add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(windows_installer)

=== src/pentobi/CMakeLists.txt ===
set(CMAKE_AUTOMOC TRUE)

if (NOT USE_QT5)
  include(${QT_USE_FILE})
endif()

include_directories(${CMAKE_SOURCE_DIR}/src)

set(pentobi_SRCS
  AnalyzeGameWidget.cpp
  AnalyzeGameWidget.h
  AnalyzeGameWindow.cpp
  AnalyzeGameWindow.h
  AnalyzeSpeedDialog.cpp
  AnalyzeSpeedDialog.h
  Application.cpp
  Application.h
  Main.cpp
  MainWindow.cpp
  MainWindow.h
  RatedGamesList.cpp
  RatedGamesList.h
  RatingDialog.cpp
  RatingDialog.h
  RatingGraph.cpp
  RatingGraph.h
  RatingHistory.cpp
  RatingHistory.h
  ShowMessage.cpp
  ShowMessage.h
  Util.cpp
  Util.h
)

set(pentobi_ICNS
  pentobi.png
  pentobi-16.png
  pentobi-32.png
  pentobi-backward.png
  pentobi-backward-16.png
  pentobi-backward10.png
  pentobi-backward10-16.png
  pentobi-beginning.png
  pentobi-beginning-16.png
  pentobi-computer-color.png
  pentobi-computer-color-16.png
  pentobi-end.png
  pentobi-end-16.png
  pentobi-flip-horizontal.png
  pentobi-flip-vertical.png
  pentobi-forward.png
  pentobi-forward-16.png
  pentobi-forward10.png
  pentobi-forward10-16.png
  pentobi-newgame.png
  pentobi-newgame-16.png
  pentobi-next-piece.png
  pentobi-next-variation.png
  pentobi-next-variation-16.png
  pentobi-piece-clear.png
  pentobi-play.png
  pentobi-play-16.png
  pentobi-previous-piece.png
  pentobi-previous-variation.png
  pentobi-previous-variation-16.png
  pentobi-rated-game.png
  pentobi-rated-game-16.png
  pentobi-rotate-left.png
  pentobi-rotate-right.png
  )

set(pentobi_TS
  pentobi.ts
  pentobi_de.ts
  pentobi_en_CA.ts
  pentobi_en_GB.ts
  )

# Create PNG icons from SVG icons using the helper program src/convert
foreach(icon ${pentobi_ICNS})
  string(REPLACE ".png" ".svg" svgicon ${icon})
  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/icons/${icon}"
    COMMAND convert ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon} ${CMAKE_CURRENT_BINARY_DIR}/icons/${icon}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
    )
endforeach()

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/icons)
configure_file(resources.qrc resources.qrc COPYONLY)

if (USE_QT5)
  qt5_add_resources(pentobi_RC_SRCS ${CMAKE_CURRENT_BINARY_DIR}/resources.qrc)
else()
  qt4_add_resources(pentobi_RC_SRCS ${CMAKE_CURRENT_BINARY_DIR}/resources.qrc)
endif()

# We don't use qt4_add_translation because it doesn't use option
# -removeidentical with lrelease, which causes larger sizes of the generated qm
# files
if (USE_QT5)
  set(LRELEASE_EXECUTABLE ${Qt5_LRELEASE_EXECUTABLE})
else()
  set(LRELEASE_EXECUTABLE ${QT_LRELEASE_EXECUTABLE})
endif()
set(pentobi_QM_SRCS)
foreach(ts ${pentobi_TS})
  get_filename_component(qm ${ts} NAME_WE)
  set(qm "${CMAKE_CURRENT_BINARY_DIR}/${qm}.qm")
  add_custom_command(OUTPUT ${qm}
    COMMAND ${LRELEASE_EXECUTABLE}
    ARGS -removeidentical -nounfinished
      ${CMAKE_CURRENT_SOURCE_DIR}/translations/${ts} -qm ${qm}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/translations/${ts} VERBATIM
    )
  set(pentobi_QM_SRCS ${pentobi_QM_SRCS} ${qm})
endforeach()

if (MINGW OR CYGWIN)
  # Workaround for a compilation failure with MINGW if we let CMake 
  # build the RC object: it would invoke windres.exe with the current
  # CXXFLAGS but some of them are GCC-specific and not supported
  # by windres.exe (e.g. -std=c++11).
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/icon.o
    COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
    -i${CMAKE_CURRENT_SOURCE_DIR}/icon.rc
    -o ${CMAKE_CURRENT_BINARY_DIR}/icon.o)
  set(pentobi_SRCS ${pentobi_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/icon.o)
else()
  set(pentobi_SRCS ${pentobi_SRCS} icon.rc)
endif()

add_executable(pentobi WIN32
  ${pentobi_SRCS}
  ${pentobi_QM_SRCS}
  ${pentobi_RC_SRCS}
  )


if(MINGW AND (CMAKE_SIZEOF_VOID_P EQUAL "4"))
  set_target_properties(pentobi PROPERTIES LINK_FLAGS -Wl,--large-address-aware)
endif()

target_link_libraries(pentobi
  pentobi_gui
  pentobi_mcts
  pentobi_base
  boardgame_base
  boardgame_sgf
  boardgame_util
  boardgame_sys
  )

# Remove once we require CMake 2.8.11
if (WIN32)
  if (USE_QT5)
    target_link_libraries(pentobi Qt5::WinMain)
  else()
    target_link_libraries(pentobi ${QT_QTMAIN_LIBRARY})
  endif()
endif()

if (USE_QT5)
  qt5_use_modules(pentobi Widgets Concurrent)
else()
  target_link_libraries(pentobi
    ${QT_QTGUI_LIBRARY}
    ${QT_QTCORE_LIBRARY}
    ${QT_QTGUI_LIB_DEPENDENCIES}
    ${QT_QTCORE_LIB_DEPENDENCIES}
    )
endif()

install(TARGETS pentobi 
DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install translation files. If you change the destination, you need to
# update the default for PENTOBI_TRANSLATIONS in the main CMakeLists.txt
install(FILES ${pentobi_QM_SRCS}
  DESTINATION ${CMAKE_INSTALL_DATADIR}/pentobi/translations)

install(DIRECTORY manual DESTINATION ${CMAKE_INSTALL_DOCDIR}
  FILES_MATCHING PATTERN "*.css" PATTERN "*.html" PATTERN "*.png")

if(MSVC)
  configure_file(pentobi.conf.in Debug/pentobi.conf @ONLY)
  configure_file(pentobi.conf.in Release/pentobi.conf @ONLY)
else()
  configure_file(pentobi.conf.in pentobi.conf @ONLY)
endif()

=== src/pentobi_gtp/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_executable(pentobi-gtp
  Engine.cpp
  Engine.h
  Main.cpp
)

target_link_libraries(pentobi-gtp
  pentobi_mcts
  pentobi_base
  boardgame_base
  boardgame_sgf
  boardgame_util
  boardgame_sys
  boardgame_gtp
  )

# On Ubuntu 13.10, pthreads is not automatically linked even if it required
# by std::thread (however it is automatically linked if we link QtCore),
# so we explicitely use FindThreads() and link it here.
if (DEFINED CMAKE_THREAD_LIBS_INIT)
  target_link_libraries(pentobi-gtp ${CMAKE_THREAD_LIBS_INIT})
endif()

if(MINGW AND (CMAKE_SIZEOF_VOID_P EQUAL "4"))
  set_target_properties(pentobi-gtp PROPERTIES LINK_FLAGS -Wl,--large-address-aware)
endif()

=== src/unittest/libboardgame_gtp/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_executable(unittest_libboardgame_gtp
  ArgumentsTest.cpp
  CmdLineTest.cpp
  EngineTest.cpp
  ResponseTest.cpp
)

target_link_libraries(unittest_libboardgame_gtp
  boardgame_test_main
  boardgame_test
  boardgame_util
  boardgame_gtp
  )

add_test(libboardgame_gtp unittest_libboardgame_gtp)

=== src/unittest/libpentobi_mcts/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_executable(unittest_libpentobi_mcts
  SearchTest.cpp
)

target_link_libraries(unittest_libpentobi_mcts
  boardgame_test_main
  pentobi_mcts
  pentobi_base
  boardgame_base
  boardgame_sgf
  boardgame_test
  boardgame_util
  boardgame_sys
  )

add_test(libpentobi_mcts unittest_libpentobi_mcts)

=== debian/changelog ===
pentobi (8.0-2) unstable; urgency=medium

  * Remove export CC/CXX lines and Build-Depends on g++-4.8 since the default
    compiler is g++-4.9 on release architectures (Closes: #751326).

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Sun, 15 Jun 2014 11:51:50 +0300

pentobi (8.0-1) unstable; urgency=medium

  * New upstream release.
  * Use more flexible file extension regex in debian/watch.
  * Symlink duplicates in the whole pentobi binary package.
  * Don’t rebuild images in d/rules, upstream build system now does it.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Thu, 06 Mar 2014 09:22:33 +0200

=== debian/control ===
Source: pentobi
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Dean Evans <dean@codemonkies.net>,
           Juhani Numminen <juhaninumminen0@gmail.com>
Build-Depends: cmake,
               debhelper (>= 9),
               kdelibs5-dev,
               libqt4-dev,
               rdfind,
               symlinks
Standards-Version: 3.9.5
Homepage: http://pentobi.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/pkg-games/pentobi.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/pentobi.git;a=summary

Package: pentobi
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: pentobi-kde-thumbnailer
Description: clone of the strategy board game Blokus
 Pentobi is a strategy board game played on a square grid board using playing
 pieces in the shapes of polyominoes, similar to Tetris pieces.  The aim of the
 game is to place all of your pieces while trying to block your opponent from
 placing all of theirs.
 .
 The game ends when no one can place any more pieces and the winner is
 determined by calculating the score based on the points of any remaining
 playing pieces. Bonus points are added for playing every piece and additional
 bonus points are added if the monomino, the 1x1 square piece, is played last.

Package: pentobi-kde-thumbnailer
Architecture: any
Section: kde
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: dolphin, konqueror
Description: clone of the strategy board game Blokus - KDE thumbnailer
 Pentobi is a strategy board game played on a square grid board using playing
 pieces in the shapes of polyominoes, similar to Tetris pieces.  The aim of the
 game is to place all of your pieces while trying to block your opponent from
 placing all of theirs.
 .
 This package contains a KDE plugin to display thumbnails of Pentobi game files.

## pentobi 8.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,11 +3,15 @@
 # Use all lower-case for project name because it is used in
 # CMAKE_INSTALL_DOCDIR of GNUInstallDirs
 project(pentobi)
-set(PENTOBI_VERSION 8.0)
+set(PENTOBI_VERSION 8.2)
 
 if(POLICY CMP0020)
   # Remove once we require CMake 2.8.11
   cmake_policy(SET CMP0020 OLD)
+endif()
+if (POLICY CMP0043)
+  # Avoid warning with CMake 3.0.1
+  cmake_policy(SET CMP0043 NEW)
 endif()
 
 include(CheckIncludeFiles)

=== data/CMakeLists.txt ===
if(PENTOBI_BUILD_GUI AND NOT WIN32)

# Create bitmap icons from SVG icons using the helper program src/convert
add_custom_target(
  pentobi.xpm ALL
  COMMAND convert ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi-32.svg pentobi.xpm
  DEPENDS ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi-32.svg
  )
add_custom_target(
  application-x-blokus-sgf.png ALL
  COMMAND convert ${CMAKE_CURRENT_SOURCE_DIR}/application-x-blokus-sgf.svg application-x-blokus-sgf.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/application-x-blokus-sgf.svg
  )
add_custom_target(
  application-x-blokus-sgf-16.png ALL
  COMMAND convert ${CMAKE_CURRENT_SOURCE_DIR}/application-x-blokus-sgf-16.svg application-x-blokus-sgf-16.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/application-x-blokus-sgf-16.svg
  )

configure_file(pentobi.desktop.in pentobi.desktop @ONLY)
configure_file(pentobi.thumbnailer.in pentobi.thumbnailer @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi.xpm
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pixmaps)
install(FILES ${CMAKE_BINARY_DIR}/src/pentobi/icons/pentobi.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
install(FILES ${CMAKE_BINARY_DIR}/src/pentobi/icons/pentobi-16.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps
  RENAME pentobi.png)
install(FILES ${CMAKE_BINARY_DIR}/src/pentobi/icons/pentobi-32.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps
  RENAME pentobi.png)
install(FILES ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi.svg
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/application-x-blokus-sgf.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/mimetypes)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/application-x-blokus-sgf-16.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/mimetypes
  RENAME application-x-blokus-sgf.png)
install(FILES application-x-blokus-sgf.svg
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/mimetypes)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi.desktop
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi.thumbnailer
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/thumbnailers)
install(FILES pentobi-mime.xml
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/mime/packages)

endif(PENTOBI_BUILD_GUI AND NOT WIN32)

=== src/CMakeLists.txt ===
add_subdirectory(books)
add_subdirectory(libboardgame_sys)
add_subdirectory(libboardgame_util)
add_subdirectory(libboardgame_sgf)
add_subdirectory(libboardgame_base)
add_subdirectory(libboardgame_mcts)
add_subdirectory(libpentobi_base)
add_subdirectory(libpentobi_mcts)

if (PENTOBI_BUILD_GTP)
  add_subdirectory(libboardgame_gtp)
  add_subdirectory(pentobi_gtp)
endif()

if (PENTOBI_BUILD_TESTS)
  add_subdirectory(libboardgame_test)
  add_subdirectory(libboardgame_test_main)
  add_subdirectory(unittest)
endif()

if (PENTOBI_BUILD_GUI)
  add_subdirectory(convert)
  add_subdirectory(libpentobi_gui)
  add_subdirectory(libpentobi_thumbnail)
  add_subdirectory(pentobi_thumbnailer)
  add_subdirectory(pentobi)
  if(PENTOBI_BUILD_KDE_THUMBNAILER)
    add_subdirectory(libpentobi_kde_thumbnailer)
    add_subdirectory(pentobi_kde_thumbnailer)
  endif()
endif()

=== src/convert/CMakeLists.txt ===
if (NOT USE_QT5)
  include(${QT_USE_FILE})
endif()

include_directories(${CMAKE_SOURCE_DIR}/src)

add_executable(convert Main.cpp)

# CMake 2.8.9 doesn't seem to support finding plugin paths yet but
# we need to add qsvg to the linked libraries if static linking is
# used as by our current build of the Windows installer with MinGW.
# This should be fixed once CMake properly supports plugins because it
# breaks the build with dynamic libraries on MinGW and doesn't solve
# the problem with static libraries on other platforms.
if (MINGW)
  add_definitions(-DQT_STATICPLUGIN)
  if(QT_DEBUG)
    target_link_libraries(convert "${QT_PLUGINS_DIR}/imageformats/libqsvgd.a")
  else()
    target_link_libraries(convert "${QT_PLUGINS_DIR}/imageformats/libqsvg.a")
  endif()
endif()

if (USE_QT5)
  qt5_use_modules(convert Widgets)
else()
  target_link_libraries(convert
    ${QT_QTSVG_LIBRARY}
    ${QT_QTGUI_LIBRARY}
    ${QT_QTCORE_LIBRARY}
    ${QT_QTGUI_LIB_DEPENDENCIES}
    ${QT_QTCORE_LIB_DEPENDENCIES}
    )
endif()

=== src/libboardgame_base/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_base STATIC
  CoordPoint.cpp
  CoordPoint.h
  Engine.cpp
  Engine.h
  Geometry.h
  GeometryUtil.h
  Grid.h
  Marker.h
  MarkerWithCount.h
  Point.h
  PointList.h
  PointTransform.h
  Rating.cpp
  Rating.h
  RectGeometry.h
  SpShtStrRep.cpp
  SpShtStrRep.h
  Transform.cpp
  Transform.h
  TrigonGeometry.h
)

=== src/libboardgame_gtp/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_gtp STATIC
  Arguments.cpp
  Arguments.h
  CmdLine.cpp
  CmdLine.h
  CmdLineRange.cpp
  CmdLineRange.h
  Engine.cpp
  Engine.h
  Failure.h
  Response.cpp
  Response.h
)

=== src/libboardgame_mcts/CMakeLists.txt ===
# This library contains only header files with templates. The empty target
# exists only to add the headers to IDE project files.
add_custom_target(boardgame_mcts SOURCES
  Atomic.h
  BiasTerm.h
  ChildIterator.h
  LastGoodReply.h
  Node.h
  PlayerMove.h
  Search.h
  Tree.h
  TreeUtil.h
)

=== src/libboardgame_sgf/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_sgf STATIC
  InvalidPropertyValue.cpp
  InvalidPropertyValue.h
  InvalidTree.cpp
  InvalidTree.h
  MissingProperty.cpp
  MissingProperty.h
  Node.cpp
  Node.h
  Reader.cpp
  Reader.h
  Tree.cpp
  Tree.h
  TreeIterator.cpp
  TreeIterator.h
  TreeReader.cpp
  TreeReader.h
  TreeWriter.cpp
  TreeWriter.h
  Util.cpp
  Util.h
  Writer.cpp
  Writer.h
)

=== src/libboardgame_sys/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_sys STATIC
  Compiler.h
  CpuTime.cpp
  CpuTime.h
  Memory.cpp
  Memory.h
)

=== src/libboardgame_test/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_test STATIC
  Test.cpp
  Test.h
)

=== src/libboardgame_test_main/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_test_main STATIC Main.cpp)

=== src/libboardgame_util/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_util STATIC
  Abort.cpp
  Abort.h
  ArrayList.h
  Assert.cpp
  Assert.h
  Barrier.cpp
  Barrier.h
  BitMarker.h
  CpuTime.cpp
  CpuTime.h
  Exception.cpp
  Exception.h
  FastLog.cpp
  FastLog.h
  FmtSaver.h
  IntervalChecker.cpp
  IntervalChecker.h
  Log.cpp
  Log.h
  NullElement.h
  NullTermList.h
  Options.cpp
  Options.h
  RandomGenerator.cpp
  RandomGenerator.h
  Statistics.h
  StringUtil.cpp
  StringUtil.h
  TimeIntervalChecker.cpp
  TimeIntervalChecker.h
  Timer.cpp
  Timer.h
  TimeSource.cpp
  TimeSource.h
  Unused.h
  WallTime.cpp
  WallTime.h
)

=== debian/changelog ===
pentobi (8.2-1) unstable; urgency=medium

  * New upstream release.
    - Fixes link error on some platforms if Pentobi is compiled with
      PENTOBI_BUILD_TESTS (Closes: #759852).
  * Update Vcs-Browser field.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Sat, 06 Sep 2014 09:23:17 +0300

=== debian/control ===
--- 
+++ 
@@ -11,9 +11,9 @@
                rdfind,
                symlinks
 Standards-Version: 3.9.5
-Homepage: http://pentobi.sourceforge.net/
+Homepage: http://pentobi.sourceforge.net
 Vcs-Git: git://anonscm.debian.org/pkg-games/pentobi.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/pentobi.git;a=summary
+Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/pentobi.git
 
 Package: pentobi
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
DH_ALWAYS_EXCLUDE:=CVS:.svn:.svnignore:.git:.gitignore

# Optimize with O3 to make the computationally expensive higher levels faster.
export DEB_CXXFLAGS_MAINT_STRIP  = -O2
export DEB_CXXFLAGS_MAINT_APPEND = -O3
# Link “as needed” to minimize the dependencies of the KDE thumbnailer on
# KDE libraries it doesn’t actually use.
export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_BINDIR=/usr/games \
			-DCMAKE_INSTALL_DATADIR=/usr/share/games \
			-DPENTOBI_BUILD_KDE_THUMBNAILER=ON \
			-DPENTOBI_BUILD_TESTS=ON

override_dh_install:
	rm -f debian/tmp/usr/share/doc/pentobi/COPYING
	mv debian/tmp/usr/share/doc/pentobi/NEWS \
			debian/tmp/usr/share/doc/pentobi/changelog
	dh_install
# Replace duplicate files in pentobi binary package with symlinks.
	rdfind -outputname /dev/null -makesymlinks true debian/pentobi
	symlinks -rsc debian/pentobi

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/kde4/pentobi-thumbnail.so

%:
	dh $@ --parallel

## pentobi 9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Use all lower-case for project name because it is used in
 # CMAKE_INSTALL_DOCDIR of GNUInstallDirs
 project(pentobi)
-set(PENTOBI_VERSION 8.2)
+set(PENTOBI_VERSION 9.0)
 
 if(POLICY CMP0020)
   # Remove once we require CMake 2.8.11
@@ -20,9 +20,20 @@
 option(PENTOBI_BUILD_TESTS "Build unit tests" OFF)
 option(PENTOBI_BUILD_GTP "Build GTP interface" OFF)
 option(PENTOBI_BUILD_GUI "Build Qt-based GUI" ON)
-option(PENTOBI_BUILD_KDE_THUMBNAILER
-  "Build thumbnailer for KDE (also requires PENTOBI_BUILD_GUI)" OFF)
+option(PENTOBI_BUILD_QML "Build QtQuick-based GUI" OFF)
+option(PENTOBI_BUILD_KDE_THUMBNAILER "Build thumbnailer for KDE" OFF)
 option(USE_QT5 "Use Qt 5 instead of Qt 4" OFF)
+
+if (PENTOBI_BUILD_KDE_THUMBNAILER AND USE_QT5)
+  message(FATAL_ERROR "PENTOBI_BUILD_KDE_THUMBNAILER requires USE_QT5=0")
+endif()
+if (PENTOBI_BUILD_KDE_THUMBNAILER AND NOT PENTOBI_BUILD_GUI)
+  message(FATAL_ERROR
+    "PENTOBI_BUILD_KDE_THUMBNAILER requires PENTOBI_BUILD_GUI=1")
+endif()
+if (PENTOBI_BUILD_QML AND NOT USE_QT5)
+  message(FATAL_ERROR "PENTOBI_BUILD_QML requires USE_QT5=1")
+endif()
 
 if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   message(STATUS "No build type selected, default to Release")
@@ -80,12 +91,19 @@
 
 if(PENTOBI_BUILD_GUI)
   if (USE_QT5)
+    find_package(Qt5Concurrent REQUIRED)
     find_package(Qt5Widgets REQUIRED)
-    find_package(Qt5Concurrent REQUIRED)
     find_package(Qt5LinguistTools REQUIRED)
+    find_package(Qt5Svg REQUIRED)
   else()
     find_package(Qt4 COMPONENTS QtCore QtGui QtSvg REQUIRED)
   endif()
+endif()
+if(PENTOBI_BUILD_QML)
+  find_package(Qt5Concurrent 5.3 REQUIRED)
+  find_package(Qt5Qml 5.3 REQUIRED)
+  find_package(Qt5Gui 5.3 REQUIRED)
+  find_package(Qt5Svg 5.3 REQUIRED)
 endif()
 
 if(UNIX)
@@ -106,4 +124,4 @@
 add_subdirectory(doc)
 add_subdirectory(src)
 add_subdirectory(data)
-add_subdirectory(windows_installer)
+add_subdirectory(windows)

=== src/books/CMakeLists.txt ===
# Install the opening book files. If you change the destination, you need to
# update the default for PENTOBI_BOOKS_DIR in the main CMakeLists.txt
install(FILES
  book_classic.blksgf
  book_classic_2.blksgf
  book_classic_3.blksgf
  book_duo.blksgf
  book_junior.blksgf
  book_trigon.blksgf
  book_trigon_2.blksgf
  book_trigon_3.blksgf
  DESTINATION ${CMAKE_INSTALL_DATADIR}/pentobi/books)

=== src/libboardgame_base/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_base STATIC
  CoordPoint.h
  CoordPoint.cpp
  Engine.h
  Engine.cpp
  Geometry.h
  GeometryUtil.h
  Grid.h
  Marker.h
  Point.h
  PointList.h
  PointTransform.h
  Rating.h
  Rating.cpp
  RectGeometry.h
  SpShtStrRep.h
  SpShtStrRep.cpp
  Transform.h
  Transform.cpp
  TrigonGeometry.h
)

=== src/libboardgame_gtp/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_gtp STATIC
  Arguments.h
  Arguments.cpp
  CmdLine.h
  CmdLine.cpp
  CmdLineRange.h
  CmdLineRange.cpp
  Engine.h
  Engine.cpp
  Failure.h
  Response.h
  Response.cpp
)

=== src/libboardgame_mcts/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
   LastGoodReply.h
   Node.h
   PlayerMove.h
-  Search.h
+  SearchBase.h
   Tree.h
   TreeUtil.h
 )

=== src/libboardgame_sgf/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_sgf STATIC
  InvalidPropertyValue.h
  InvalidTree.h
  MissingProperty.h
  MissingProperty.cpp
  Reader.h
  Reader.cpp
  SgfNode.h
  SgfNode.cpp
  SgfTree.h
  SgfTree.cpp
  SgfUtil.h
  SgfUtil.cpp
  TreeIterator.h
  TreeIterator.cpp
  TreeReader.h
  TreeReader.cpp
  TreeWriter.h
  TreeWriter.cpp
  Writer.h
  Writer.cpp
)

=== src/libboardgame_sys/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_sys STATIC
  Compiler.h
  CpuTime.h
  CpuTime.cpp
  Memory.h
  Memory.cpp
)

=== src/libboardgame_test/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_test STATIC
  Test.h
  Test.cpp
)

=== src/libboardgame_util/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(boardgame_util STATIC
  Abort.h
  Abort.cpp
  ArrayList.h
  Assert.h
  Assert.cpp
  Barrier.h
  Barrier.cpp
  CpuTimeSource.h
  CpuTimeSource.cpp
  Exception.h
  Exception.cpp
  FastLog.h
  FastLog.cpp
  FmtSaver.h
  IntervalChecker.h
  IntervalChecker.cpp
  Log.h
  Log.cpp
  MathUtil.h
  NullElement.h
  NullTermList.h
  Options.h
  Options.cpp
  RandomGenerator.h
  RandomGenerator.cpp
  Statistics.h
  StringUtil.h
  StringUtil.cpp
  TimeIntervalChecker.h
  TimeIntervalChecker.cpp
  Timer.h
  Timer.cpp
  TimeSource.h
  TimeSource.cpp
  Unused.h
  WallTimeSource.h
  WallTimeSource.cpp
)

=== src/libpentobi_base/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)

set(pentobi_base_STAT_SRCS
  AdjDiagIterator.h
  AdjIterator.h
  BoardConst.h
  BoardConst.cpp
  Board.h
  Board.cpp
  BoardUpdater.h
  BoardUpdater.cpp
  BoardUtil.h
  BoardUtil.cpp
  Book.h
  Book.cpp
  Color.h
  Color.cpp
  ColorMap.h
  ColorMove.h
  DiagIterator.h
  Game.h
  Game.cpp
  GameStateHistory.h
  GameStateHistory.cpp
  Geometry.h
  Grid.h
  Marker.h
  Move.h
  MoveInfo.h
  MoveList.h
  MoveMarker.h
  MovePoints.h
  NodeUtil.h
  NodeUtil.cpp
  PentobiSgfUtil.h
  PentobiSgfUtil.cpp
  PentobiTree.h
  PentobiTree.cpp
  PentobiTreeWriter.h
  PentobiTreeWriter.cpp
  Piece.h
  PieceInfo.h
  PieceInfo.cpp
  PieceMap.h
  PieceTransformsClassic.h
  PieceTransformsClassic.cpp
  PieceTransformsClassic.h
  PieceTransforms.cpp
  PieceTransformsTrigon.h
  PieceTransformsTrigon.cpp
  PlayerBase.h
  PlayerBase.cpp
  Point.h
  PointList.h
  PointState.h
  PointState.cpp
  PrecompMoves.h
  ScoreUtil.h
  Setup.h
  StartingPoints.h
  StartingPoints.cpp
  SymmetricPoints.h
  SymmetricPoints.cpp
  TreeUtil.h
  TreeUtil.cpp
  Variant.h
  Variant.cpp
)

if (PENTOBI_BUILD_GTP)
  set(pentobi_base_STAT_SRCS ${pentobi_base_STAT_SRCS}
    Engine.cpp
    Engine.h
  )
endif()

add_library(pentobi_base STATIC ${pentobi_base_STAT_SRCS})

=== src/libpentobi_gui/CMakeLists.txt ===
set(CMAKE_AUTOMOC TRUE)

if (NOT USE_QT5)
  include(${QT_USE_FILE})
endif()

include_directories(${CMAKE_SOURCE_DIR}/src)

set(pentobi_gui_STAT_SRCS
  BoardPainter.h
  BoardPainter.cpp
  ComputerColorDialog.h
  ComputerColorDialog.cpp
  GameInfoDialog.h
  GameInfoDialog.cpp
  GuiBoard.h
  GuiBoard.cpp
  GuiBoardUtil.h
  GuiBoardUtil.cpp
  HelpWindow.h
  HelpWindow.cpp
  InitialRatingDialog.h
  InitialRatingDialog.cpp
  LeaveFullscreenButton.h
  LeaveFullscreenButton.cpp
  LineEdit.h
  LineEdit.cpp
  OrientationDisplay.h
  OrientationDisplay.cpp
  PieceSelector.h
  PieceSelector.cpp
  SameHeightLayout.h
  SameHeightLayout.cpp
  ScoreDisplay.h
  ScoreDisplay.cpp
  Util.h
  Util.cpp
)

set(pentobi_gui_ICNS
  go-home.png
  go-next.png
  go-previous.png
)

set(pentobi_gui_TS
  libpentobi_gui_de.ts
  libpentobi_gui_en_CA.ts
  libpentobi_gui_en_GB.ts
  )

# Create PNG icons from SVG icons using the helper program src/convert
foreach(icon ${pentobi_gui_ICNS})
  string(REPLACE ".png" ".svg" svgicon ${icon})
  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/icons/${icon}"
    COMMAND convert ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon} ${CMAKE_CURRENT_BINARY_DIR}/icons/${icon}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
    )
endforeach()

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/icons)
configure_file(
  libpentobi_gui_resources.qrc libpentobi_gui_resources.qrc COPYONLY)

if (USE_QT5)
  qt5_add_resources(pentobi_gui_RC_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/libpentobi_gui_resources.qrc)
else()
  qt4_add_resources(pentobi_gui_RC_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/libpentobi_gui_resources.qrc)
endif()

# We don't use qt4_add_translation because it doesn't use option
# -removeidentical with lrelease, which causes larger sizes of the generated qm
# files
if (USE_QT5)
  set(LRELEASE_EXECUTABLE ${Qt5_LRELEASE_EXECUTABLE})
else()
  set(LRELEASE_EXECUTABLE ${QT_LRELEASE_EXECUTABLE})
endif()
set(pentobi_gui_QM_SRCS)
foreach(ts ${pentobi_gui_TS})
  get_filename_component(qm ${ts} NAME_WE)
  set(qm "${CMAKE_CURRENT_BINARY_DIR}/${qm}.qm")
  add_custom_command(OUTPUT ${qm}
    COMMAND ${LRELEASE_EXECUTABLE}
    ARGS -removeidentical -nounfinished
      ${CMAKE_CURRENT_SOURCE_DIR}/translations/${ts} -qm ${qm}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/translations/${ts} VERBATIM
    )
  set(pentobi_gui_QM_SRCS ${pentobi_gui_QM_SRCS} ${qm})
endforeach()

add_library(pentobi_gui STATIC
  ${pentobi_gui_STAT_SRCS}
  ${pentobi_gui_RC_SRCS}
  ${pentobi_gui_QM_SRCS})

if (USE_QT5)
  qt5_use_modules(pentobi_gui Widgets)
endif()

# Install translation files. If you change the destination, you need to
# update the default for PENTOBI_TRANSLATIONS in the main CMakeLists.txt
install(FILES ${pentobi_gui_QM_SRCS}
  DESTINATION ${CMAKE_INSTALL_DATADIR}/pentobi/translations)

=== src/libpentobi_kde_thumbnailer/CMakeLists.txt ===
# libpentobi_kde_thumbnailer contains the files needed by
# the pentobi_kde_thumbnailer plugin compiled with shared library options
# (usually -fPIC) because this is required for building shared libraries on
# some targets (e.g. x86_64).
#
# The alternative would be to add -fPIC to the global compiler flags even for
# executables but this slows down Pentobi's search by 10% on some targets.
#
# Adding the source files directly to pentobi_kde_thumbnailer/CMakeList.txt is
# not possible because the KDE CMake macros add -fno-exceptions to the
# compiler flags which causes errors in the Pentobi sources that use
# exceptions (which should be fine as long as no exceptions are thrown
# from the thumbnailer plugin functions).

include(${QT_USE_FILE})

add_definitions(${CMAKE_SHARED_LIBRARY_CXX_FLAGS})

include_directories(${CMAKE_SOURCE_DIR}/src)

set(pentobi_kde_thumbnailer_STAT_SRCS
  ../libboardgame_util/Assert.cpp
  ../libboardgame_util/Exception.cpp
  ../libboardgame_util/Log.cpp
  ../libboardgame_util/StringUtil.cpp
  ../libboardgame_base/SpShtStrRep.cpp
  ../libboardgame_sgf/MissingProperty.cpp
  ../libboardgame_sgf/Reader.cpp
  ../libboardgame_sgf/SgfNode.cpp
  ../libboardgame_sgf/SgfTree.cpp
  ../libboardgame_sgf/TreeReader.cpp
  ../libpentobi_base/NodeUtil.cpp
  ../libpentobi_base/StartingPoints.cpp
  ../libpentobi_base/Variant.cpp
  ../libpentobi_gui/BoardPainter.cpp
  ../libpentobi_gui/Util.cpp
  ../libpentobi_thumbnail/CreateThumbnail.cpp
  )

add_library(pentobi_kde_thumbnailer STATIC
  ${pentobi_kde_thumbnailer_STAT_SRCS}
)

=== debian/changelog ===
pentobi (9.0-1) experimental; urgency=medium

  * New upstream release. Upload to experimental.
  * Restructure debian/rules.
  * Do not find and symlink duplicate files, not needed anymore.
  * Bump Standards-Version to 3.9.6, no changes needed.
  * Do not install README, which has no useful information.
  * Support noopt in DEB_BUILD_OPTIONS.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Sun, 14 Dec 2014 13:52:01 +0200

=== debian/control ===
--- 
+++ 
@@ -7,10 +7,8 @@
 Build-Depends: cmake,
                debhelper (>= 9),
                kdelibs5-dev,
-               libqt4-dev,
-               rdfind,
-               symlinks
-Standards-Version: 3.9.5
+               libqt4-dev
+Standards-Version: 3.9.6
 Homepage: http://pentobi.sourceforge.net
 Vcs-Git: git://anonscm.debian.org/pkg-games/pentobi.git
 Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/pentobi.git

=== debian/rules ===
#!/usr/bin/make -f

# Optimize with O3 to make the computationally expensive higher levels faster.
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
  export DEB_CXXFLAGS_MAINT_APPEND = -O3
endif

# Avoid dependencies on unused libraries.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=/usr/games \
		-DCMAKE_INSTALL_DATADIR=/usr/share/games \
		-DPENTOBI_BUILD_KDE_THUMBNAILER=ON \
		-DPENTOBI_BUILD_TESTS=ON

override_dh_install:
	dh_install -XCOPYING -XNEWS -XREADME

override_dh_installchangelogs:
	dh_installchangelogs NEWS

# The KDE thumbnailer .so file is a plugin.
override_dh_makeshlibs:
